;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
ret

;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT/OUTPUT: TEMP													  
; rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp								
UMWANDLUNG_7_SEGMENT:
	cpi temp,'0'
	breq UMWANDLUNG_7_SEGMENT_0
	cpi temp,'1'
	breq UMWANDLUNG_7_SEGMENT_1
	cpi temp,'2'
	breq UMWANDLUNG_7_SEGMENT_2
	cpi temp,'3'
	breq UMWANDLUNG_7_SEGMENT_3
	cpi temp,'4'
	breq UMWANDLUNG_7_SEGMENT_4
	cpi temp,'5'
	breq UMWANDLUNG_7_SEGMENT_5
	cpi temp,'6'
	breq UMWANDLUNG_7_SEGMENT_6
	cpi temp,'7'
	breq UMWANDLUNG_7_SEGMENT_7
	cpi temp,'8'
	breq UMWANDLUNG_7_SEGMENT_8
	cpi temp,'9'
	breq UMWANDLUNG_7_SEGMENT_9

	; AUS	
	cpi temp,0
	breq UMWANDLUNG_7_SEGMENT_AUS
	; MINUS	
	cpi temp,'-'
	breq UMWANDLUNG_7_SEGMENT_MINUS

	rjmp UMWANDLUNG_7_SEGMENT_ERROR


	; ERROR		
	ldi temp,0b10000110
	ret
UMWANDLUNG_7_SEGMENT_0:	;
	;ldi temp,0b11000000	
	ldi temp,0b00111111
	ret
UMWANDLUNG_7_SEGMENT_1:	;
	;ldi temp,0b11111001
	 ldi temp,0b00000110
	ret
UMWANDLUNG_7_SEGMENT_2:	;
	;ldi temp,0b10100100
	ldi  temp,0b01011011
	ret
UMWANDLUNG_7_SEGMENT_3:	;
	;ldi temp,0b10110000
	ldi  temp,0b01001111
	ret
UMWANDLUNG_7_SEGMENT_4:	;
	;ldi temp,0b10011001
	ldi  temp,0b01100110
	ret
UMWANDLUNG_7_SEGMENT_5:	;
	;ldi temp,0b10010010
	ldi  temp,0b01101101
	ret
UMWANDLUNG_7_SEGMENT_6:	;
	;ldi temp,0b10000010
	ldi  temp,0b01111101
	ret
UMWANDLUNG_7_SEGMENT_7:	;
	;ldi temp,0b11111000
	ldi  temp,0b00000111
	ret
UMWANDLUNG_7_SEGMENT_8:	;
	;ldi temp,0b10000000
	ldi temp, 0b01111111
	ret
UMWANDLUNG_7_SEGMENT_9:	;
	;ldi temp,0b10010000
	ldi temp, 0b01101111
	ret
UMWANDLUNG_7_SEGMENT_AUS:	;
	;ldi temp,0b11111111
	ldi temp, 0b00000000
	ret
UMWANDLUNG_7_SEGMENT_MINUS:	;
	;ldi temp,0b10111111
	ldi temp, 0b01000000
	ret
UMWANDLUNG_7_SEGMENT_ERROR:	;
	ldi temp, 0b01011100
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################