; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	; ZIFFER aus	
	sbi PORTC,0
	sbi PORTC,1
	sbi PORTC,2
	sbi PORTC,3			
	; BALKEN aus	
	sbi PORTB,0
	sbi PORTB,1
	sbi PORTB,2
	sbi PORTB,3
	sbi PORTB,4
	sbi PORTB,5
	sbi PORTD,6
	sbi PORTD,7
	; Pause			
	rcall wait_100ms
	; BALKEN an
	cbi PORTD,6	
	; ZIFFER an	
	rcall wait_100ms
	cbi PORTC,0
	rcall wait_100ms
	cbi PORTC,1
	rcall wait_100ms
	cbi PORTC,2
	rcall wait_100ms
	cbi PORTC,3			
	rcall wait_100ms
	; BALKEN an
	cbi PORTB,0
	rcall wait_100ms
	cbi PORTB,1
	rcall wait_100ms
	cbi PORTB,2
	rcall wait_100ms
	cbi PORTB,3
	rcall wait_100ms
	cbi PORTB,4
	rcall wait_100ms
	cbi PORTB,5
	rcall wait_100ms
	cbi PORTD,6
	rcall wait_100ms
	; BALKEN aus	
	sbi PORTB,0
	sbi PORTB,1
	sbi PORTB,2
	sbi PORTB,3
	sbi PORTB,4
	sbi PORTB,5
	sbi PORTD,6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca. 0,1s Pause												
WAIT_100ms:
	push temp1          ; temp1 auf dem Stack sichern            
	push temp2          ; temp2 auf dem Stack sichern            
	push temp3          ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,6			;(6 bei 16MHz)			
	clr temp2
	clr	temp1			
WAIT_100ms_w:	
	wdr
	dec	 temp1
	brne WAIT_100ms_w
	dec	 temp2		
	brne WAIT_100ms_w
	dec	 temp3
	brne WAIT_100ms_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz Takt ca.1s Pause													
WAIT_1s:
	push temp1          ; temp1 auf dem Stack sichern            
	push temp2          ; temp2 auf dem Stack sichern            
	push temp3          ; temp3 auf dem Stack sichern            

;------------
	ldi	temp3,60		;(60 bei 16MHz)			
	clr temp2
	clr	temp1			
wait1s_w:	
	wdr
	dec	temp1
	brne	wait1s_w
	dec	temp2		
	brne	wait1s_w
	dec	temp3
	brne	wait1s_w
;------------
	pop temp3      		; temp3 wiederherstellen                    
	pop temp2      		; temp2 wiederherstellen                    
	pop temp1      		; temp1 wiederherstellen                    
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################