; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
;	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; *	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(1<<CS02)|(0<<CS01)|(0<<CS00)
	OUT TCCR0,temp
; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER1_INITIALISIERUNG:
;																			
; Timer1 (16Bit ) Vorteiler 												
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
;																			
;CS12 CS11 CS10 Description													
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
;	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
; *	1 	0 	1 	clkI/O/1024 (From prescaler)								
;	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
;																			
	ldi temp,(1<<CS12)|(0<<CS11) |(1<<CS10)
	out TCCR1B,temp          
; Timer 1 Startwert 	
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp     
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
; ------------------------------------------------------------------------------
; Ziffer-Zhler			
	LDS temp,(adr_ZIFFER_ZAEHLER)	; laden		
	inc temp						; +1		
	cpi temp,3+1					; vergleich	
	brne TIM0_OVF_ZIFFER_Z
	clr temp
TIM0_OVF_ZIFFER_Z:
	STS(adr_ZIFFER_ZAEHLER),temp	; speichern
; ------------------------------------------------------------------------------
	; ZIFFER aus	
	sbi PORTC,0
	sbi PORTC,1
	sbi PORTC,2
	sbi PORTC,3	
	; BALKEN aus	
	sbi PORTB,0
	sbi PORTB,1
	sbi PORTB,2
	sbi PORTB,3
	sbi PORTB,4
	sbi PORTB,5
	sbi PORTD,6
	sbi PORTD,7
; ------------------------------------------------------------------------------
	cpi temp,0		; vergleich	
	breq TIM0_OVF_ZIFFER_0_ON
	cpi temp,1		; vergleich	
	breq TIM0_OVF_ZIFFER_1_ON
	cpi temp,2		; vergleich	
	breq TIM0_OVF_ZIFFER_2_ON
	rjmp TIM0_OVF_ZIFFER_3_ON

TIM0_OVF_ZIFFER_0_ON:
	cbi PORTC,0						; ZIFFER an	
	LDS temp,(adr_ZIFFER_WERT_0) 	; Wert laden
	rjmp TIM0_OVF_ZIFFER_ON_FERTIG
TIM0_OVF_ZIFFER_1_ON:
	cbi PORTC,1						; ZIFFER an	
	LDS temp,(adr_ZIFFER_WERT_1) 	; Wert laden
	rjmp TIM0_OVF_ZIFFER_ON_FERTIG
TIM0_OVF_ZIFFER_2_ON:
	cbi PORTC,2						; ZIFFER an	
	LDS temp,(adr_ZIFFER_WERT_2) 	; Wert laden
	rjmp TIM0_OVF_ZIFFER_ON_FERTIG
TIM0_OVF_ZIFFER_3_ON:
	cbi PORTC,3						; ZIFFER an	
	LDS temp,(adr_ZIFFER_WERT_3) 	; Wert laden
	rjmp TIM0_OVF_ZIFFER_ON_FERTIG
TIM0_OVF_ZIFFER_ON_FERTIG:
; ------------------------------------------------------------------------------
; Balken A+B+C+D+E+F		
	com temp
	out PORTB,temp
; Balken G+PUNKT			
	com temp	
	andi temp, 0b11000000 

	cpi  temp, 0b10000000 
	breq TIM0_OVF_PUNKT_AN
	cpi  temp, 0b01000000 
	breq TIM0_OVF_G_AN
	cpi  temp, 0b11000000 
	breq TIM0_OVF_BEIDE_AN
	rjmp TIM0_OVF_FERTIG

TIM0_OVF_G_AN:
	cbi PORTD,6	
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_PUNKT_AN:
	cbi PORTD,7	
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_BEIDE_AN:
	cbi PORTD,6	
	cbi PORTD,7	
	rjmp TIM0_OVF_FERTIG
TIM0_OVF_FERTIG:
; ------------------------------------------------------------------------------
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz ==> 1s Takt														
TIM1_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
	push TEMP5
	push TEMP6
	push TEMP7
	push TEMP8  	
	push TEMP9  	
; ----------------------------------
; Timer Startwert	 				
	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp
; ----------------------------------
	; PROGRAMM freigeben		 
	STS (adr_FREIGABE_PROGRAMM),EINS
; -------------------------------
	rcall ZEIT


; ----------------------------------
	pop TEMP9  	
	pop TEMP8
	pop TEMP7
	pop TEMP6
	pop TEMP5
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT:
	LDS temp,(adr_ss)	; aus SRAM laden	
	inc temp
	STS (adr_ss),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_MM
	ret	
ZEIT_MM:
	STS (adr_ss),NULL	; in SRAM speichern	

	LDS temp,(adr_mm)	; aus SRAM laden	
	inc temp
	STS (adr_mm),temp	; in SRAM speichern	
	cpi temp,60
	brsh ZEIT_HH
	ret	
ZEIT_HH:
	STS (adr_mm),NULL	; in SRAM speichern	

	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	STS (adr_hh),temp	; in SRAM speichern	
	cpi temp,24
	brsh ZEIT_TAG
	ret	
ZEIT_TAG:
	STS (adr_hh),NULL	; in SRAM speichern	

	LDS temp,(adr_TAG)	; aus SRAM laden	
	inc temp
	STS (adr_TAG),temp	; in SRAM speichern	
	
	rcall ZEIT_TAGE_IM_MONAT
	cp temp,temp1 
	brsh ZEIT_MONAT
	ret
; MONAT					
ZEIT_MONAT:
	STS (adr_TAG),EINS

	LDS temp,(adr_MONAT); aus SRAM laden	
	inc temp
	STS (adr_MONAT),temp; in SRAM speichern	
	cpi temp,13 
	brsh ZEIT_JAHR
	ret
; JAHR					
ZEIT_JAHR:
	STS (adr_MONAT),EINS

	LDS temp,(adr_JAHR)	; aus SRAM laden	
	inc temp
	STS (adr_JAHR),temp	; in SRAM speichern	

ret
; Anzahl der TAGE im Monat	
ZEIT_TAGE_IM_MONAT:
	LDS temp1,(adr_MONAT)

ZEIT_TAGE_IM_MONAT_01:			; Januar	
	cpi temp1,1
	brne ZEIT_TAGE_IM_MONAT_02
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_02:			; Februar	
	cpi temp1,2
	brne ZEIT_TAGE_IM_MONAT_03
	ldi temp1,28
	ret
ZEIT_TAGE_IM_MONAT_03:			; Mrz		
	cpi temp1,3
	brne ZEIT_TAGE_IM_MONAT_04
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_04:			; April		
	cpi temp1,4
	brne ZEIT_TAGE_IM_MONAT_05
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_05:			; Mai		
	cpi temp1,5
	brne ZEIT_TAGE_IM_MONAT_06
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_06:			; Juni		
	cpi temp1,6
	brne ZEIT_TAGE_IM_MONAT_07
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_07:			; Juli		
	cpi temp1,7
	brne ZEIT_TAGE_IM_MONAT_08
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_08:			; August	
	cpi temp1,8
	brne ZEIT_TAGE_IM_MONAT_09
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_09:			; September	
	cpi temp1,8
	brne ZEIT_TAGE_IM_MONAT_10
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_10:			; Oktober	
	cpi temp1,10
	brne ZEIT_TAGE_IM_MONAT_11
	ldi temp1,31
	ret
ZEIT_TAGE_IM_MONAT_11:			; November	
	cpi temp1,11
	brne ZEIT_TAGE_IM_MONAT_12
	ldi temp1,30
	ret
ZEIT_TAGE_IM_MONAT_12:			; Dezember	
	ldi temp1,31
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################