

;												
; LED WECKER									
; Bernhard.Erfurt@gmx.de						
; 11/2010										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> Balken A								
; PB1 ==> Balken B								
; PB2 ==> Balken C								
; PB3 ==> Balken D								
; PB4 ==> Balken E								
; PB5 ==> Balken F								
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> Ziffer 0  (1er rechts)				
; PC1 ==> Ziffer 1  (10er)						
; PC2 ==> Ziffer 2	(100er)						
; PC3 ==> Ziffer 3	(1000er						
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> Balken G								
; PD7 ==> Balken Punkt							
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	

; TIMER-WERTE					
.equ TIMERWERT0 =256-250			;(2 hoch 8  minus...)		bei 16MHz + Vorteiler   64 => 0.001s 	
.equ TIMERWERT1	=65536-15625		;(2 hoch 16 minus....15625) bei 16MHz + Vorteiler 1024 => 1s 		

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_FREIGABE_PROGRAMM		=0x0060+5

.equ adr_ss						=0x0060+10
.equ adr_mm						=0x0060+11
.equ adr_hh						=0x0060+12
.equ adr_TAG					=0x0060+13
.equ adr_MONAT					=0x0060+14
.equ adr_JAHR					=0x0060+15


.equ adr_ZIFFER_ZAEHLER			=0x0060+18

.equ adr_ZIFFER_WERT_0			=0x0060+20
.equ adr_ZIFFER_WERT_1			=0x0060+21
.equ adr_ZIFFER_WERT_2			=0x0060+22
.equ adr_ZIFFER_WERT_3			=0x0060+23


; EEPROM-BELEGUNG ATmega8						
.equ adr_EEPROM_DATEN			= 0
.equ EEPROM_WERKSEINSTELLUNG	= 0


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   	  	; Timer1 Overflow Handler           					
rjmp TIM0_OVF   		; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00111111	; LED-BALKEN 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00111111	;
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00001111	; ZIFFER
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	;
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11100000	; LED-Balken
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b01100000	;
	out PORTD, temp				

; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR

; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
	

; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; ZEIT				
	ldi temp,1
	STS(adr_hh),temp	
	ldi temp,1
	STS(adr_mm),temp		
	ldi temp,30
	STS(adr_ss),temp		

	; DATUM				
	STS(adr_TAG),  EINS			; in SRAM speichern		
	STS(adr_MONAT),EINS			; in SRAM speichern		
	STS(adr_JAHR), EINS			; in SRAM speichern		

; LED-TEST							
	rcall LED_TEST

; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################





; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR		; Watch-Dog-RESET	
	SLEEP
;-----------------------------------
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp
	breq LOOP
	STS(adr_FREIGABE_PROGRAMM),NULL
	WDR		; Watch-Dog-RESET		
;-----------------------------------

	rcall UHRZEIT_ANZEIGEN

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "WECKER_TIMER.asm"
.include "WECKER_EEPROM.asm"
.include "WECKER_SONSTIGES.asm"
.include "WECKER_FUNKTIONEN.asm"
.include "WECKER_LED.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################


